#!/usr/bin/env perl5.14.2
# retweeter.pl
# https://gist.github.com/briandfoy/5478591
use Net::Twitter;
use v5.10;

die "Specify the original tweet id!\n" unless defined $ARGV[0];

# get your own credentials at https://dev.twitter.com/apps/new
my $nt = Net::Twitter->new(
  traits   => [qw/OAuth API::RESTv1_1/],
    map { $_ => $ENV{"twitter_$_"} || die "ENV twitter_$_ not set" }
        qw(
            consumer_secret
            consumer_key
            access_token
            access_token_secret
            )
    );
die "Could not make Twitter object!\n" unless defined $nt;

my $retweets = $nt->retweets( { id => $ARGV[0], count => 100 } );

say "Found " . @$retweets . " retweets for $ARGV[0]";

my @retweet_users =
    map  { $_->{user}{screen_name} }
    @$retweets;

my $chosen = int rand( @retweet_users );
say "The winner is $retweet_users[$chosen]!";